<?php
/************************************************
 * Plugin d'onglet
 * file : plugin_thumbs.php
 * version: 2.00
 * date: 01/02/2012
 * author: Arnaud Fornerot
  ************************************************/
/*
 * name: Plugin Thumbs
 * description: Plugin EOLE - Gestion des onglets selon le profil. Attention !! Ce plugin n'est pas désactivable.
 * display:  style="font-weight:bolder;"
 * dependencies: no
 * author: Gaston TJEBBES
 * url: http://eole.orion.education.fr
 */


define("THUMBS_NAME","plugin thumbs");
register_hook("userinterface_header","thumbs_userinterface_header",2,1);

require_once("/var/www/html/posh/includes/connection_mysql.inc.php");

function thumb_exporter(){
  echo "<link type='text/css' rel='stylesheet' media='screen' href='../includes/plugins/plugin_thumbs/styles/exporter.css' />";
  echo '<script type="text/javascript" src="../includes/plugins/plugin_thumbs/scripts/exporter.js"></script>';
}

function thumbs_userinterface_header($page)
{
	global $DB1;
	global $DB2;
	global $DB3;
	global $DB4;
	global $authentif_getUserByName;

	$fgdebug=false;

	include_once("/var/www/html/posh-profil/include/envole.php");
	if($fgdebug) echo "Connection base poshprofile : ".$config['dblogin']." ".$config['dbpassword']." ".$config['dbname'];

	$DB1 = new connection(__SERVER,__LOGIN,__PASS,__DB);
	$DB2 = new connection($config['dbhost'],$config['dblogin'],$config['dbpassword'],$config['dbname']);
	$DB3 = new connection(__SERVER,__LOGIN,__PASS,__DB);
	$DB4 = new connection($config['dbhost'],$config['dblogin'],$config['dbpassword'],$config['dbname']);


	$tbattrs 		= array();		// Liste des attributs associés à l'utilisateur
	$tbprofs 		= array();		// Liste des profils associés à l'utilisateur
	$tbprofsname 	= array();		// Liste des noms de profils associés à l'utilisateur
	$tbidogs 		= array();		// Liste des id d'onglets assoicés à l'utilisateur
	$tbnmogs 		= array();		// Liste des name d'onglets assoicés à l'utilisateur
	$tbongls 		= array();		// Liste des onglets assoicés à l'utilisateur


	if(__defaultAuthen == "cas" && $page == "portal/mypage.php"){

		EolephpCAS::client(__CAS_VERSION,__CAS_SERVER,__CAS_PORT,__CAS_FOLDER,true);
		if (__CAS_VALIDER_CA) {
			EolephpCAS::setCasServerCACert(__CAS_CA_LOCATION); // vérification par rapport à la CA
		} else {
			if (method_exists("EolephpCAS", "setNoCasServerValidation")){
				EolephpCAS::setNoCasServerValidation();
			}
		}
		if ( method_exists(EolephpCAS, 'EoleLogoutRequests') ) EolephpCAS::EoleLogoutRequests(false);

		if(EolephpCAS::isAuthenticated())
		{
			if($fgdebug) echo "<h1>ANCIENNE GESTION DES ONGLETS</h1>";

			// recuperation des infos utilisateurs envoyees par le SSO
			$user = EolephpCAS::getUser();
			$details = EolephpCAS::getDetails();
			$user_datas = array('user'=>$user, 'details'=>$details);

/*==LISTE DES PROFILS DE L'UTLISATEUR CONNECTE========================================================================================================*/

			// Profil Ban
			$ban=false;

			// Parcours de l'ensemble des informations détaillées de l'utilisateur
			if($fgdebug) echo "<br><br>LISTE DES ATTRIBUTS ASSOCIES";
			if ($user_d = current($user_datas["details"])) {
				while ($user = current($user_d)) {
					$key=key($user_d);
					if($fgdebug) echo "<br><br><em>$key</em>";

					foreach ($user as $u) {
						if($fgdebug) echo "<br>".$u;

						// On recherche s'il exite un attribut parametré pour cette valeur
						$DB2->getResults("SELECT * FROM userattr WHERE attrname='".$DB2->escape($key)."' AND attrvalue='".$DB2->escape($u)."'");

						// Si oui on sauvegarde l'id de l'attribut
						if ($row = $DB2->fetch(0)) {
							array_push($tbattrs,$row['userattrid']);
							if($fgdebug) echo "<span style='color: red;font_width: strong;'> >> OK</span> >> ".$row['userattrid'];
						}
					}

					next($user_d);
				}
			}

			// Pour l'ensemble des attributs qui correspondent à l'utilisateur
			if($fgdebug) echo "<br><br>LISTE DES PROFILS ASSOCIES";
			while ($idattr = current($tbattrs)) {
				// On parcourt l'ensemble des profils associés
				$DB2->getResults("SELECT * FROM userattrprofile, profile WHERE userattrid=$idattr AND userattrprofile.profileid=profile.profileid");
				while ($row = $DB2->fetch(0)) {
					if(!in_array($row['profileid'],$tbprofs)) {
						if($fgdebug) echo "<br>".$row['name'];
						array_push($tbprofs,$row['profileid']);
						array_push($tbprofsname,$row['name']);
						
						if($row['ban']==1) {
							$ban=true;
							$banurl=$row['banurl'];
						}

					}
				}
				next($tbattrs);
			}

			// Ajouter qu'il arrive l'utilisateur par défaut
			$DB2->getResults("SELECT * FROM profile WHERE name='main_user'");
			if ($row = $DB2->fetch(0)) {
				if(!in_array($row['profileid'],$tbprofs)) {
					if($fgdebug) echo "<br>".$row['name'];
					array_push($tbprofs,$row['profileid']);
					array_push($tbprofsname,$row['name']);
					if($row['ban']==1) $ban=true;
				}
			}

			// Ban
			if($ban) {
				if(isset($banurl)&&!empty($banurl)) {					
					header("Location: ".$banurl."");
				} else {
					echo "<h1 style='margin-top:200px'><center>Vous n'êtes pas autorisé à vous connecter au Portail</center></h1>";
					die();
				}			
			}

//==ANCIENNE GESTION DES ONGLETS=====================================================================================================================*/

			if($fgdebug) echo "<br><br><em>LOGIN : </em>".$user;
			if($fgdebug) echo "<br><em>ID : </em>".$_SESSION['user_id'];

			// Pour l'ensemble des onglets posh liè à un model d'onglet on vérifie que le modèle existe toujours
			if($fgdebug) echo "<br><br>SUPPRESSION DES ONGLETS WIDGET SANS TEMPLATE";
			$DB1->getResults("SELECT * FROM profile WHERE user_id=".$_SESSION['user_id']." AND pass!='' AND type=1");
			while ($row = $DB1->fetch(0)) {
				if($fgdebug) echo "<br>".$row['pass'];

				$DB2->getResults("SELECT * FROM thumb WHERE name='".$row['pass']."'");
				if ($rowthumb = $DB2->fetch(0)) {
					$idthumb	= $rowthumb['thumbid'];
					$idpage		= $rowthumb['admin_profile_id'];

					if($fgdebug) echo " > lié au template ".$idpage;

					// Si la page template n'existe plus on supprime le thumb et la page courrante
					$DB3->getResults("SELECT * FROM profile WHERE id=$idpage");
					if(!($rowtemplate = $DB3->fetch(0))) {
						if($fgdebug) echo " > <span style='color:red'>A Supprimer</span>";

						$DB2->execute("DELETE FROM thumb WHERE thumbid=$idthumb");
						$DB2->execute("DELETE FROM profilethumb WHERE thumbid=$idthumb");

						$DB3->execute("DELETE FROM profile WHERE id='".$row['id']."'");
						$DB3->execute("DELETE FROM module WHERE profile_id='".$row['id']."'");
						$DB3->execute("DELETE FROM users_notes WHERE profile_id='".$row['id']."'");
					}
				}
			}


			// Pour l'ensemble des profils qui correspond à l'utilisateur
			if($fgdebug) echo "<br><br>LISTE DES ONGLETS ASSOCIES";
			while ($idprof = current($tbprofs)) {
				// On parcourt l'ensemble des onglets qui correspondent à l'utilisateur
				$DB2->getResults("SELECT * FROM profilethumb, thumb WHERE profilethumb.profileid=$idprof AND profilethumb.thumbid=thumb.thumbid");
				while ($row = $DB2->fetch(0)) {
					if(!in_array($row['thumbid'],$tbidogs)) {
						if($fgdebug) echo "<br>".$row['description'];

						array_push($tbidogs,$row['thumbid']);
						array_push($tbnmogs,$row['name']);

						$tmpongls = array($row['thumbid'],$row['name'],$row['description'],$row['indice'],$row['poshtype'],$row['url'],$row['admin_profile_id']);
						array_push($tbongls,$tmpongls);
					}
				}
				next($tbprofs);

			}


			// Pour l'ensemble des onglets posh on vérifie qu'il existe toujours dans poshprofil
			if($fgdebug) echo "<br><br>SUPPRESSION DES ONGLETS OBSOLETES";
			$DB1->getResults("SELECT * FROM profile WHERE user_id=".$_SESSION['user_id']." AND pass!=''");
			while ($row = $DB1->fetch(0)) {
				if(!in_array($row['pass'],$tbnmogs)) {
					if($fgdebug) echo "<br>Onglet ".$row['name']." à supprimer";
					$DB3->execute("DELETE FROM profile WHERE id='".$row['id']."'");
					$DB3->execute("DELETE FROM module WHERE profile_id='".$row['id']."'");
					$DB3->execute("DELETE FROM users_notes WHERE profile_id='".$row['id']."'");
				}
			}

			// Pour l'ensemble des onglets qui correspond à l'utilisateur
			if($fgdebug) echo "<br><br>GENERATION DES ONGLETS POSH";
			while ($tmpongls = current($tbongls)) {
				if($fgdebug) echo "<br>".$tmpongls[0]." ".$tmpongls[1];

				// On vérifie que l'onglet existe pour l'utilisateur
				$DB1->getResults("SELECT * FROM profile WHERE user_id=".$_SESSION['user_id']." AND pass='".$tmpongls[1]."'");

				// Si existe on regarde si mise à jour nécessaire
				$fgupdate=false;
				if ($row = $DB1->fetch(0)) {
					if($row['name']!=$tmpongls[2]||$row['seq']!=$tmpongls[3]||$row['type']!=$tmpongls[4]||$row['param']!=$tmpongls[5]||$row['removable']!='0') {
						if($fgdebug) echo "<br>Modification Onglet : ".$tmpongls[2];
						if($tmpongls[4]==1) $fgcontrol="N";
						else $fgcontrol="Y";
						$fgupdate=true;

						$DB3->execute("UPDATE profile SET name='".addslashes($tmpongls[2])."',seq='".$tmpongls[3]."',type='".$tmpongls[4]."',param='".$tmpongls[5]."',removable='0', controls='$fgcontrol' WHERE user_id='".$_SESSION['user_id']."' AND pass='".$tmpongls[1]."'");
					}
				}

				// Sinon création de l'onglet
				else {
					if($fgdebug) echo "<br>Création Onglet : ".$tmpongls[2];
					if($tmpongls[4]==1) $fgcontrol="N";
					else $fgcontrol="Y";
					$DB3->execute("INSERT INTO profile(user_id,name,pass,seq,type,param,removable,controls) VALUES('".$_SESSION['user_id']."','".addslashes($tmpongls[2])."','".$tmpongls[1]."','".$tmpongls[3]."','".$tmpongls[4]."','".$tmpongls[5]."','0','$fgcontrol')");
				}

				// Si type widget duplication des modules de la page
				$DB1->getResults("SELECT * FROM profile WHERE user_id=".$_SESSION['user_id']." AND pass='".$tmpongls[1]."'");
				if ($row = $DB1->fetch(0)) {

					// Regeneration des widgets associés au template
					if($tmpongls[4]==1&&$tmpongls[6]!="") {
						if($fgdebug) echo " >>> <span style='color:green;'>Duplication Widgets</span>";
						$idduplicate=$row['id'];
						$width=$row['width'];
						$height=$row['height'];
						// Recherche de l'onglet dupliqué
						$DB1->getResults("SELECT * FROM profile WHERE id=".$tmpongls[6]);
						if ($row = $DB1->fetch(0)) {
							// Mise à jour de l'onglet si hauteur et largeur différente du modèle
							if($row['width']!=$width||$row['height']!=$height) {
								$DB3->execute("UPDATE profile SET width='".$row['width']."',height='".$row['height']."' WHERE id=".$idduplicate);
							}

							// Supprime les widgets qui ne sont plus présent
							$DB1->getResults("SELECT * FROM module WHERE profile_id=$idduplicate");
							while ($row = $DB1->fetch(0)) {

								$DB3->getResults("SELECT * FROM module WHERE profile_id='".$tmpongls[6]."' AND uniq='".$row['uniq']."'");
								if (!($notrow = $DB3->fetch(0))) {
									$DB3->getResults("DELETE FROM module WHERE profile_id=$idduplicate AND uniq='".$row['uniq']."'");
								}
							}
						}

						// Duplication des widgets
						$DB1->getResults("SELECT * FROM module WHERE profile_id=".$tmpongls[6]);
						//echo "SELECT * FROM module WHERE profile_id='.$tmpongls[6].'";
						while ($row = $DB1->fetch(0)) {
							// On recherche si le widget existe déjà.
							$DB3->getResults("SELECT * FROM module WHERE profile_id=$idduplicate AND uniq=".$row['uniq']);
							if ($rowwid = $DB3->fetch(0)) {
								$DB3->execute("UPDATE module SET posx='".$row['posx']."' , posy='".$row['posy']."' , posj='".$row['posj']."' , x='".$row['x']."' , y='".$row['y']."' WHERE profile_id=$idduplicate AND uniq=".$row['uniq']);
							}
							else {
								$DB3->execute("INSERT INTO module (item_id,user_id,profile_id,posx,posy,posj,x,y,typ,variables,uniq,blocked,minimized,old_id,feed_id,currentview,shared) VALUES('".$row['item_id']."','".$_SESSION['user_id']."','$idduplicate','".$row['posx']."','".$row['posy']."','".$row['posj']."','".$row['x']."','".$row['y']."','".$row['typ']."','','".$row['uniq']."','".$row['blocked']."','".$row['minimized']."','".$row['old_id']."','".$row['feed_id']."','".$row['currentview']."','".md5($idduplicate.$row['uniq'].strtotime("now"))."')");
							}

							// Duplicatin de la colonne Variable que pour les widgets de type RSS / Html / Ressource
							$DB3->getResults("SELECT * FROM module, dir_item WHERE profile_id=$idduplicate AND uniq=".$row['uniq']." AND item_id=id AND (url='../modules/p_rss.php?' OR url='../modules/p_html.php?' OR dir_item.typ='U')");
							if ($rowupd = $DB3->fetch(0)) {
								if($rowupd['variables']!=$row['variables']) {
									$DB3->execute("UPDATE module SET variables='".$DB3->escape($row['variables'])."'  WHERE profile_id=$idduplicate AND uniq=".$row['uniq']);
								}
							}
						}

					}
				}


				next($tbongls);
			}

			// FIXME : a n'éxécuter que si on est admin, comment configurer d'autre user ?
			if(EolephpCAS::getUser() == 'admin'){
				if($fgdebug) echo "<br><br><br>CREATION OBJET EXPORT PAGE";
				thumb_exporter();
			}


//==NOUVELLE GESTION DES ONGLETS=====================================================================================================================*/
			if($fgdebug) echo "<h2>NOUVELLE GESTION DES ONGLETS</h1>";
			$DB2->execute("UPDATE profile SET categorie=0 WHERE categorie IS NULL");
			
			// Recherche du groupe Posh = Profile Posh
			$tbcat=array();
			if($fgdebug) echo "Recherche du groupe  = Profile Posh<br>";
			$DB1->getResults("SELECT * FROM users_group WHERE name='Profile Posh'");
			if ($row = $DB1->fetch(0)) {
				$idparent=$row['id'];
				$tbcat[0]=$idparent;

				if($fgdebug) echo "Génération des groupes manquant<br>";

				// Création des catégories
				$DB2->getResults("SELECT * FROM catprofile");
				while ($row = $DB2->fetch(0)) {
					// Si le groupe posh n'existe pas on le génère
					$DB1->getResults("SELECT * FROM users_group WHERE name='Cat = ".$row['name']."' AND parent_id='$idparent'");
					if (!($notrow = $DB1->fetch(0))) {
						if($fgdebug) echo "Création Cat = ".$row['name']."<br>";
						$DB1->execute("INSERT INTO users_group (name, parent_id) VALUES ('Cat = ".$row['name']."','$idparent' )");
					}

					$DB1->getResults("SELECT * FROM users_group WHERE name='Cat = ".$row['name']."' AND parent_id='$idparent'");
					if ($rowtmp = $DB1->fetch(0)) {
						$idcategorie=$rowtmp['id'];
						$tbcat[$row['id']]=$idcategorie;

						// Parcourt de l'ensemble des profils posh pour voir s'il y a correspondance dans les groupe posh
						$DB4->getResults("SELECT * FROM profile WHERE categorie=".$row['id']);
						while ($rowtmp = $DB4->fetch(0)) {
							if($fgdebug) echo "Création = ".$rowtmp['name']."<br>";
							// Si le groupe posh n'existe pas on le génère
							$DB1->getResults("SELECT * FROM users_group WHERE name='".$rowtmp['name']."' AND parent_id='$idcategorie'");
							if (!($notrow = $DB1->fetch(0))) {
								$DB1->execute("INSERT INTO users_group (name, parent_id) VALUES ('".$rowtmp['name']."','$idcategorie' )");
							}
						}
					}
				}

				// Parcourt de l'ensemble des profils posh pour voir s'il y a correspondance dans les groupe posh
				$DB2->getResults("SELECT * FROM profile WHERE categorie=0");
				while ($row = $DB2->fetch(0)) {
					// Si le groupe posh n'existe pas on le génère
					$DB1->getResults("SELECT * FROM users_group WHERE name='".$row['name']."' AND parent_id='$idparent'");
					if (!($notrow = $DB1->fetch(0))) {
						$DB1->execute("INSERT INTO users_group (name, parent_id) VALUES ('".$row['name']."','$idparent' )");
					}
				}

				// Parcourt de l'ensembles des groupe posh pour voir s'il y a correspondance les profils posh
				if($fgdebug) echo "Suppression des groupes obsolètes<br>";
				foreach ($tbcat as $value) {
					$DB1->getResults("SELECT * FROM users_group WHERE name NOT LIKE('Cat = %') AND parent_id='$value'");
					while ($row = $DB1->fetch(0)) {
						// Si le propfil posh n'existe pas on supprime le groupe posh
						$key=array_search($value,$tbcat,true);

						$DB2->getResults("SELECT * FROM profile WHERE name='".$row['name']."' AND Categorie=$key");
						if (!($notrow = $DB2->fetch(0))) {
							$DB1->execute("DELETE FROM users_group_map WHERE group_id='".$row['id']."'");
							$DB1->execute("DELETE FROM users_group_widget_map WHERE group_id='".$row['id']."'");
							$DB1->execute("DELETE FROM users_group_category_map WHERE group_id='".$row['id']."'");
							$DB1->execute("DELETE FROM users_group WHERE id='".$row['id']."'");
						}
					}
				}

				// Pour l'ensemble des profils de l'utilisateur on s'assure qu'il est bien lié au groupe posh
				while ($idprofname = current($tbprofsname)) {
					if($fgdebug) echo "Lier l'utilisateur au groupe = $idprofname<br>";

					foreach ($tbcat as $value) {
						$DB1->getResults("SELECT * FROM users_group WHERE name='".$idprofname."' AND parent_id='$value'");
						if ($row = $DB1->fetch(0)) {
							$DB1->getResults("SELECT * FROM users_group_map WHERE group_id='".$row['id']."' AND user_id='".$_SESSION['user_id']."'");
							if (!($notrow = $DB1->fetch(0))) {
								$DB1->execute("INSERT INTO users_group_map (group_id, user_id) VALUES ('".$row['id']."','".$_SESSION['user_id']."' )");
							}
						}
					}

					next($tbprofsname);
				}

				// Pour l'ensembles des groupes posh de l'utilisateur on vérifie qu'il appartient toujours au profil posh
				foreach ($tbcat as $value) {
					$DB1->getResults("SELECT * FROM users_group_map, users_group WHERE user_id='".$_SESSION['user_id']."' AND group_id=id AND parent_id='$value'");
					while ($row = $DB1->fetch(0)) {
						if(!in_array($row['name'],$tbprofsname)) {
							if($fgdebug) echo "Détacher l'utilisateur du groupe = ".$row['name']."<br>";
							$DB3->execute("DELETE FROM users_group_map WHERE group_id='".$row['id']."' AND user_id='".$_SESSION['user_id']."'");
						}
					}
				}
			}


			if($fgdebug) echo "<br><br><br>";
			if($fgdebug) die();
		}
	}
}

?>
